from Tkinter import *
import time

sudokudict = {}
sudokugeloest = {}
# festewerte = {}
versuche = 0

def solve():
    global versuche
    versuche = 0
    starttime = time.time()
    for x in sudokudict:
        # festewerte[x] = {}
        sudokugeloest[x] = {}
        for y in sudokudict[x]:
            # festewerte[x][y] = 0
            sudokugeloest[x][y] = 0
            get = sudokudict[x][y].get()
            if get: # check if the entered stuff is valid
                if not get.isdigit():
                    sudokudict[x][y].delete(0,END)
                elif int(get) not in (1,2,3,4,5,6,7,8,9):
                    sudokudict[x][y].delete(0,END)
                
                else:
                     sudokugeloest[x][y] = int(get)
                     # festewerte[x][y] = int(get)
    solveBacktrack(1,1)
    print "Solving took %.6f seconds with %s tries\n" % ((time.time()-starttime),versuche)
    outputSolution((time.time()-starttime),versuche)

def solveBacktrack(x,y):
    if y == 10:
        # Zeilenende erreicht
        y = 1
        x += 1
    if x == 10 and y == 1:
        # Abbruch wenn man am Ende angekommen ist
        return True

    if sudokugeloest[x][y] > 0:
        # sudokugeloest[x][y] = festewerte[x][y]
        
        # printLsg()
        return solveBacktrack(x,y+1)

    for z in range(1,10):
        if not check(x,y,z):
            sudokugeloest[x][y] = z
            # printLsg()
            if solveBacktrack(x,y+1):
                return True
            
    sudokugeloest[x][y] = 0
    return False
    
def check(x,y,value):
    global versuche
    versuche += 1
    if checkHorizontal(x,value):
        return True
    if checkVertical(y,value):
        return True
    if checkSquare(x,y,value):
        return True
    
    return False


def convertCoordToSquare(x,y):
    """ Returned die obere linke ecke der box der gegebenen koordinate """
    for a in range(1,4):
        if x > (a-1)*3 and x <= a*3:
            for b in range(1,4):
                if y > (b-1)*3 and y <= b*3:
                    return (a-1)*3+1,(b-1)*3+1

def checkHorizontal(x,value):
    for a in range(1,10):
        if value == sudokugeloest[x][a]:
            return True
    return False
    
def checkVertical(y,value):
    for a in range(1,10):
        if value == sudokugeloest[a][y]:
            return True
    return False

def checkSquare(x,y,value):
    x_length,y_length = convertCoordToSquare(x,y)
    for a in range(x_length,x_length+3):
        for b in range(y_length,y_length+3):
            if value == sudokugeloest[a][b]:
                return True
    
    return False
        
def printLsg():
    print "-"*10
    tempcount = 0
    tempstring = ""
    for x in sudokugeloest:
        for y in sudokugeloest[x]:
            tempcount += 1
            tempstring = tempstring + str(sudokugeloest[x][y])
            if tempcount == 3 or tempcount == 6:
            
                tempstring = tempstring + " "
            elif tempcount == 9:
                tempstring = tempstring + "\n"
                tempcount = 0
            

    print tempstring
    print "-"*10

    

# ===========
# GUI Stuff
# ===========

root = Tk()
root.title("Sudoku Solver")
Label(root, text="Sudoku Solver").grid(row=0, column=0, columnspan=12, sticky=W+E)
tempx = 0
for x in range(1,12):
    if x != 4 and x != 8:
        tempx +=1
        sudokudict[tempx] = {}
        tempy = 0
    for y in range(0,11):

        if y == 3 or y == 7:
            Label(root, text="|", underline=0).grid(row=x, column=y)
        elif x == 4 or x == 8:
            Label(root, text="____", underline=0).grid(row=x, column=y)
        else:
            tempy += 1
            sudokudict[tempx][tempy]=Entry(root,width=5)
            sudokudict[tempx][tempy].grid(row=x,column=y)



Button(root, text="Solve",padx=2, command=solve).grid(row=14, column=4, columnspan=3, sticky=W+E)

def outputSolution(time,tries):
    root2 = Tk()
    root2.title("Solution")
    Label(root2, text="Sudoku Solver").grid(row=0, column=0, columnspan=12, sticky=W+E)
    tempx = 0
    for x in range(1,12):
        if x != 4 and x != 8:
            tempx +=1
            tempy = 0
        for y in range(0,11):

            if y == 3 or y == 7:
                Label(root2, text="|", underline=0).grid(row=x, column=y)
            elif x == 4 or x == 8:
                Label(root2, text="____", underline=0).grid(row=x, column=y)
            else:
                tempy += 1
                Label(root2, text=sudokugeloest[tempx][tempy], relief=GROOVE,padx=5).grid(row=x, column=y)

    Label(root2, text="Solving took %.6f seconds with %s tries"%(time,tries), relief=GROOVE,padx=5).grid(row=13,columnspan=12, column=0)

root.mainloop()
